# `utter new auth` generates a new microservice and add the gist of this into it.
require 'ssd'
require 'sinatra/base'
require 'json'

class Entity 
  include SSD
  attr_accessor :id, :token
  def initialize
  end
end


class Provider < Sinatra::Base

  #TODO should be post
  get '/signup' do 
    p params
    p id = params[:id]
    token = Random.new_seed.to_s 

    entity 	= Utter::User.new
    p entity.id 	= id
    p entity.ssd 	= id
    p entity.token 	= token
    entity.append!
    {:id=>id, :token=>token}.to_json 
  end

  get '/login' do 
    if !params[:id].nil? && !params[:token].nil? then
      p params
      id 	= params[:id]
      token = params[:token]
      entity = Utter::User.ssd id
      p "entity.id from the stored ssd"
      p entity.id == id
      p "entity.token from the stored ssd"
      p entity.token 
      p token
      if entity.id == id && entity.token == token then
	{:message => "access granted"}.to_json
      else
	{:message => "access denied"}.to_json
      end
    else
      {:message => "please supply matching id and token"}.to_json
    end
  end
  run!
end


=begin
#TODO write RDoc
module Utter
  module Internals
    class Auth < Rack::Auth::Basic #TODO digest is better than basic?
      def call(env)
	request = Rack::Request.new(env)

	case request.path when '/docs'
	  @app.call(env)  # skip auth to access documentation
	else
	  super           # perform auth
	  #TODO use json "sinatra/json" here  to ensure all outcoming response are in json

	  #res = Rack::Response.new

	  # This will automatically set the Content-Length header for you
	  ##res.write "Hello from Rack!"

	  # You can get/set headers with square bracket syntax:
	  ##res["Content-Type"] = "Content-type: application/json; charset=utf-8"

	  # returns the standard [status, headers, body] array
	  ##res.finish

	  # You can set and delete cookies
	  #   res.set_cookie("user_id", 1)
	  #   res.delete_cookie("user_id"
	end
      end
    end

    # Any class that inherits from Endpoint, may include Utter::Token to add security
    # token, a token can be used for authenticating a signed-in user or as an API for your system.
    #
    # Usage
    # 
    # via curl https://api.example.com/v1/endpoint_name -u token_value:
    # via Browser http://token_value@localhost:4567/
    # If you need to authenticate via bearer auth (e.g., for a cross-origin request), use -H "Authorization: Bearer #{token_value}" instead of -u token_value:
    #
    # More Info
    # - https://en.wikipedia.org/wiki/Digest_access_authentication
    # - https://github.com/rack/rack/blob/master/lib/rack/auth/basic.rb
    module Secured
      def self.included(base)
	base.class_eval do

	  use Auth, "#{self}" do |username, password| 

	    $log.info "username #{username}, password #{username}"

	    if !username.nil? && !password.nil? then
	      if !User.ssd(username).nil? then
		if password == User.ssd(username).password then
		  true # Access Granted
		else 
		  false # Access Denied
		end
	      end
	    end
	  end

	  # 404 Error!
	  not_found do
	    status 404
	    "404 - Check #{self} API documentation"
	  end

	end
      end
    end

  end
end
=end
